#!/usr/bin/webif-page
<? 
. /usr/lib/webif/webif.sh

header "Proxy" "Settings" "@TR<<Proxy Settings>>"

prepare_files()
{
        if [ -h /etc/packetprotector.conf ] ; then
                cp /etc/packetprotector.conf /etc/packetprotector.conf.ORIG
                rm /etc/packetprotector.conf
                cp /rom/etc/packetprotector.conf /etc/packetprotector.conf
        fi
}

proxy_stop()
{
	iptables -t nat -D prerouting_rule -i br0 -p tcp --dport 80 -j REDIRECT --to-port 8080
	echo 'Redirection disabled.'
	echo '<br />'
	killall dansguardian
	killall squid 
	echo 'Waiting for DansGuardian processes to terminate...'
	echo '<br />'
	echo '<pre>'
	DG_RUNNING=1
	while [ $DG_RUNNING = 1 ] ; do
		ps | grep `cat /var/run/dansguardian.pid` | grep -v grep
		if [ $? != 0 ] ; then
			DG_RUNNING=0
		fi
		sleep 2
	done	
	echo '</pre>'
	echo '<br />'
	echo 'Done.'
	echo '<br /><br />'
}

BASEDIR="/packetprotector"
PROXY_ENABLED=`egrep "^dansguardian=" /etc/packetprotector.conf | cut -d "=" -f 2`
CF_ENABLED=`egrep "^dansguardian_cf=" /etc/packetprotector.conf | cut -d "=" -f 2`

if [ "$FORM_enabled" ] ; then
        if [ "X$FORM_enabled" = "X1" ] ; then
                if [ "X$PROXY_ENABLED" = "X1" ] ; then
			prepare_files
                        touch /etc/packetprotector.conf
                else
			prepare_files
                        /bin/sed -i "s/^dansguardian=.*/dansguardian=1/" /etc/packetprotector.conf
			echo 'Starting Dansguardian...'
			echo '<pre>'
			$BASEDIR/etc/init.d/dansguardian > /dev/null
			echo '</pre>'
                fi
                echo '<br />Enabled.'
                echo '<br /><br />'
        elif [ "X$FORM_enabled" = "X0" ] ; then
                if [ "X$PROXY_ENABLED" = "X1" ] ; then
			prepare_files
			proxy_stop
                        /bin/sed -i "s/^dansguardian=.*/dansguardian=0/" /etc/packetprotector.conf
                fi
                echo 'Disabled.'
                echo '<br /><br />'
        else
                echo 'Invalid value for variable "enabled".'
        fi
fi

if [ "$FORM_cfenabled" ] ; then
        if [ "X$FORM_cfenabled" = "X1" ] ; then
                if [ "X$CF_ENABLED" = "X1" ] ; then
			prepare_files
                        touch /etc/packetprotector.conf
                else
			prepare_files
                        /bin/sed -i "s/^dansguardian_cf=.*/dansguardian_cf=1/" /etc/packetprotector.conf
			echo '<pre>'
			cp /$BASEDIR/etc/dansguardian/lists/weightedphraselist.FILTERED /$BASEDIR/etc/dansguardian/lists/weightedphraselist
			echo 'Restarting Dansguardian.  This will take a couple of minutes.'
			proxy_stop
			sleep 5
			echo 'Stopped.'
			echo 'Starting...'
			$BASEDIR/etc/init.d/dansguardian > /dev/null
			echo '</pre>'
                fi
                echo '<br />Content filter enabled.'
                echo '<br /><br />'
        elif [ "X$FORM_cfenabled" = "X0" ] ; then
                if [ "X$CF_ENABLED" = "X1" ] ; then
			prepare_files
			cp /$BASEDIR/etc/dansguardian/lists/weightedphraselist.OPEN /$BASEDIR/etc/dansguardian/lists/weightedphraselist
                        /bin/sed -i "s/^dansguardian_cf=.*/dansguardian_cf=0/" /etc/packetprotector.conf
			echo '<pre>'
			echo 'Restarting Dansguardian.  This will take a couple of minutes.'
			proxy_stop
			sleep 5
			echo 'Stopped.'
			echo 'Starting...'
			$BASEDIR/etc/init.d/dansguardian > /dev/null
			echo '</pre>'
                fi
                echo 'Content filter disabled.'
                echo '<br /><br />'
        else
                echo 'Invalid value for variable "cfenabled".'
        fi
fi

if [ "$FORM_update" ] ; then
	echo '<pre>'
	echo 'Running fleshclam to check for updates...'
	/packetprotector/usr/sbin/freshclam --config-file=/packetprotector/etc/freshclam.conf
	echo ''
	echo 'Done.'
	echo '</pre>'
	echo '<br /><br />'
fi

PROXY_ENABLED=`egrep "^dansguardian=" /etc/packetprotector.conf | cut -d "=" -f 2`
CF_ENABLED=`egrep "^dansguardian_cf=" /etc/packetprotector.conf | cut -d "=" -f 2`
echo '<form enctype="multipart/form-data" method="post">'
if [ "X$PROXY_ENABLED" = "X1" ] ; then
	echo '<input type="radio" name="enabled" value="1" checked> Enabled'
	echo '<input type="radio" name="enabled" value="0"> Disabled'
else
	echo '<input type="radio" name="enabled" value="1"> Enabled'
	echo '<input type="radio" name="enabled" value="0" checked> Disabled'
fi
echo '<input type="submit" name="submit_enabled" value="Submit">'
echo '</form>'

echo '<form enctype="multipart/form-data" method="post">'
if [ "X$PROXY_ENABLED" = "X1" ] ; then
	echo '<br />'
	echo '<form enctype="multipart/form-data" method="post">'
	CF_ENABLED=`egrep "^dansguardian_cf=" /etc/packetprotector.conf | cut -d "=" -f 2`
	echo 'Content filter (pornography, gambling, etc.)-<br />'
	if [ "X$CF_ENABLED" = "X1" ] ; then
		echo '<input type="radio" name="cfenabled" value="1" checked> Enabled'
		echo '<input type="radio" name="cfenabled" value="0"> Disabled'
	else
		echo '<input type="radio" name="cfenabled" value="1"> Enabled'
		echo '<input type="radio" name="cfenabled" value="0" checked> Disabled'
	fi
	echo '<input type="submit" name="submit_cf" value="Submit">'
	echo '</form>'
	
	echo '<br />'
	DB_VERSION=`/packetprotector/usr/sbin/freshclam --config-file=/packetprotector/etc/freshclam.conf -V | cut -d"/" -f 2`
	DB_LASTUPDATE=`/packetprotector/usr/sbin/freshclam --config-file=/packetprotector/etc/freshclam.conf -V | cut -d"/" -f 3`
	echo 'Using ClamAV database version '$DB_VERSION'.  Last updated '$DB_LASTUPDATE'.'
	echo '<br />'
	echo '<br />'
	echo '<form enctype="multipart/form-data" method="post">'
	echo '<input type="submit" name="update" value="Check for ClamAV signature updates.">'	
	echo '</form>'
fi

echo '<br /><br />'

footer ?>
<!--
##WEBIF:name:Proxy:2:Settings
-->
