#!/usr/bin/webif-page
<? 
. /usr/lib/webif/webif.sh

header "IDS" "Log" "@TR<<Snort Log>>"

LD_LIBRARY_PATH=/packetprotector/usr/lib/

if [ ! -e /bin/tac ] ; then
	ln -s /packetprotector/usr/sbin/tac /bin/tac
fi
if [ ! -e /bin/tcpdump ] ; then
	ln -s /packetprotector/usr/sbin/tcpdump /bin/tcpdump
fi

if [ "$FORM_IP" ] ; then
	echo 'Displaying activity for '$FORM_IP' (oldest to newest)-<br /><br />'
	echo '<pre>'
	for i in `ls -rt /tmp/log/snort/snort.log*`; do
		tcpdump -n -X -r $i host $FORM_IP 2> /dev/null | sed "s/>/\&gt;/g" | sed "s/</\&lt;/g" || echo 'Error retrieving logs!<br />';
	done 
	echo '</pre>'

else	

   SNORT_ENABLED=`egrep "^snort=" /etc/packetprotector.conf | cut -d "=" -f 2`

   if [ "X$SNORT_ENABLED" = "X1" ] ; then

	START=1
	END=50
	if [ "$FORM_start" ] && [ "$FORM_end" ] ; then
		START=$FORM_start
		END=$FORM_end
	fi
	TAIL=`expr $END - $START + 1`

	TOTAL=`wc -l /tmp/log/snort/alert* | tail -1 | cut -d"t" -f1 |  cut -d"/" -f1 | sed "s/ *//"`
	if [ "$TOTAL" -eq 0 ] ; then
		echo 'No alerts.'

	elif [ "$TOTAL" -lt $END ] ; then
		echo 'Displaying '$START' through '$TOTAL' of '$TOTAL'records.<br />'
		TAIL=`expr $TOTAL - $START + 1`
		#PREVIOUS
		if [ "$START" -gt 50 ] ; then
			PREVIOUS_START=`expr $START - 50`
			PREVIOUS_END=`expr $END - 50`	
			echo '<a href=/cgi-bin/webif/snort-log.sh?start='$PREVIOUS_START'&end='$PREVIOUS_END'>Previous</a><br />'
		fi

	else
		echo 'Displaying '$START' through '$END' of '$TOTAL'records.<br />'
		#PREVIOUS
		if [ "$START" -gt 50 ] ; then
			PREVIOUS_START=`expr $START - 50`
			PREVIOUS_END=`expr $END - 50`	
			echo '<a href=/cgi-bin/webif/snort-log.sh?start='$PREVIOUS_START'&end='$PREVIOUS_END'>Previous</a><br />'
		fi
		#NEXT
		NEXT_START=`expr $START + 50`
		NEXT_END=`expr $END + 50`
		echo '<a href=/cgi-bin/webif/snort-log.sh?start='$NEXT_START'&end='$NEXT_END'>Next</a><br />'
 
	fi
	echo '<br />'

	echo '<pre>'
	ls -t /tmp/log/snort/alert* | xargs tac 2> /dev/null | head -$END | tail -$TAIL | sed "s/\[\([0-9]\{1,9\}\):\([0-9]\{1,9\}\):\([0-9]\{1,9\}\)\]/\[\1:\<a href=http:\/\/www.snort.org\/pub-bin\/sigs.cgi?sid=\2 style=\"text-decoration:none\"\>\2\<\/a\>:\3\]/" | sed "s/[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}/\<a href=\/cgi-bin\/webif\/snort-log.sh?IP=& style=\"text-decoration:none\"\>&\<\/a\>/g" | /packetprotector/usr/sbin/fold -s -w 120
	echo '</pre>'

   else
	echo 'Snort is not enabled.  See the <a href=/cgi-bin/webif/snort-settings.sh>IDS Settings</a> page.'

   fi

fi

footer ?>
<!--
##WEBIF:name:IDS:1:Log
-->
